<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iParameterManager Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iParameterManager Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iParameterManager" --><!-- doxytag: inherits="iBase" -->
<p>This interface provides a generic functions for the evaluation of any type of parameter (constant, dynamic, or expression)  
 <a href="structiParameterManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="parameters_8h_source.html">tools/parameters.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iParameterManager:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiParameterManager.png" usemap="#iParameterManager_map" alt=""/>
  <map id="iParameterManager_map" name="iParameterManager_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,124,24"/>
</map>
 </div></div>

<p><a href="structiParameterManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiParameterManager.html#a7c72e14baf9d4c668d1f43ebd33b058b">FillParameterBlock</a> (<a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *params, <a class="el" href="classcelVariableParameterBlock.html">celVariableParameterBlock</a> *act_params, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelParSpec.html">celParSpec</a> &gt; &amp;parameters, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray</a>&lt; <a class="el" href="structiParameter.html">iParameter</a> &gt; &amp;quest_parameters)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Fill in the dynamic parameters in a parameter block.  <a href="#a7c72e14baf9d4c668d1f43ebd33b058b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt; <a class="el" href="structiParameter.html">iParameter</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiParameterManager.html#ad0d5a6e38732d05f2c9206cf43d67941">GetParameter</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;params, const char *param)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a parameter that can be evalulated later on an as-needed basis.  <a href="#ad0d5a6e38732d05f2c9206cf43d67941"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a><br class="typebreak"/>
&lt; <a class="el" href="classcelVariableParameterBlock.html">celVariableParameterBlock</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiParameterManager.html#abc9256cc531285f31dd0cb43f012be6f">GetParameterBlock</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;params, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelParSpec.html">celParSpec</a> &gt; &amp;parameters, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray</a>&lt; <a class="el" href="structiParameter.html">iParameter</a> &gt; &amp;quest_parameters)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a convenience function to get a parameter block during creation of rewards, triggers, and sequence operations.  <a href="#abc9256cc531285f31dd0cb43f012be6f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiParameterManager.html#a20362f81f86ca84648c18eebcb87f7bf">ResolveParameter</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;params, const char *param)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a convenience function to resolve a quest parameter during creation of rewards, triggers, and sequence operations.  <a href="#a20362f81f86ca84648c18eebcb87f7bf"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This interface provides a generic functions for the evaluation of any type of parameter (constant, dynamic, or expression) </p>

<p>Definition at line <a class="el" href="parameters_8h_source.html#l00101">101</a> of file <a class="el" href="parameters_8h_source.html">parameters.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a7c72e14baf9d4c668d1f43ebd33b058b"></a><!-- doxytag: member="iParameterManager::FillParameterBlock" ref="a7c72e14baf9d4c668d1f43ebd33b058b" args="(iCelParameterBlock *params, celVariableParameterBlock *act_params, const csArray&lt; celParSpec &gt; &amp;parameters, const csRefArray&lt; iParameter &gt; &amp;quest_parameters)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiParameterManager.html#a7c72e14baf9d4c668d1f43ebd33b058b">iParameterManager::FillParameterBlock</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelParameterBlock.html">iCelParameterBlock</a> *&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelVariableParameterBlock.html">celVariableParameterBlock</a> *&#160;</td>
          <td class="paramname"><em>act_params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelParSpec.html">celParSpec</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>parameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray</a>&lt; <a class="el" href="structiParameter.html">iParameter</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>quest_parameters</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Fill in the dynamic parameters in a parameter block. </p>
<p>Return whether or not the filling has been made. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">params</td><td>is the parameter block given to the reward. </td></tr>
    <tr><td class="paramname">msg_params</td><td>is the resolved parameter block as returned by <a class="el" href="structiParameterManager.html#abc9256cc531285f31dd0cb43f012be6f" title="This is a convenience function to get a parameter block during creation of rewards, triggers, and sequence operations.">GetParameterBlock()</a>. </td></tr>
    <tr><td class="paramname">parameters</td><td>is the parameter specifications and unparsed values. </td></tr>
    <tr><td class="paramname">quest_parameters</td><td>is an array with quest parameters. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad0d5a6e38732d05f2c9206cf43d67941"></a><!-- doxytag: member="iParameterManager::GetParameter" ref="ad0d5a6e38732d05f2c9206cf43d67941" args="(const celParams &amp;params, const char *param)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="structiParameter.html">iParameter</a>&gt; <a class="el" href="structiParameterManager.html#ad0d5a6e38732d05f2c9206cf43d67941">iParameterManager::GetParameter</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>param</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a parameter that can be evalulated later on an as-needed basis. </p>
<p>Returns 0 for an illegal parameter (error reporting has been done). </p>

</div>
</div>
<a class="anchor" id="abc9256cc531285f31dd0cb43f012be6f"></a><!-- doxytag: member="iParameterManager::GetParameterBlock" ref="abc9256cc531285f31dd0cb43f012be6f" args="(const celParams &amp;params, const csArray&lt; celParSpec &gt; &amp;parameters, csRefArray&lt; iParameter &gt; &amp;quest_parameters)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr</a>&lt;<a class="el" href="classcelVariableParameterBlock.html">celVariableParameterBlock</a>&gt; <a class="el" href="structiParameterManager.html#abc9256cc531285f31dd0cb43f012be6f">iParameterManager::GetParameterBlock</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray</a>&lt; <a class="el" href="structcelParSpec.html">celParSpec</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>parameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray</a>&lt; <a class="el" href="structiParameter.html">iParameter</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>quest_parameters</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This is a convenience function to get a parameter block during creation of rewards, triggers, and sequence operations. </p>
<p>This routine knows how to recognize parameter usage (starting with '$' or '@') and will in that case try to resolve the parameter by finding it in 'params'. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">params</td><td>is the quest parameters. </td></tr>
    <tr><td class="paramname">paramspec</td><td>is the parameter specifications and unparsed values. </td></tr>
    <tr><td class="paramname">quest_parameters</td><td>is an array that should have the same length as the 'paramspec' array. It will be filled with the parameters. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a20362f81f86ca84648c18eebcb87f7bf"></a><!-- doxytag: member="iParameterManager::ResolveParameter" ref="a20362f81f86ca84648c18eebcb87f7bf" args="(const celParams &amp;params, const char *param)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* <a class="el" href="structiParameterManager.html#a20362f81f86ca84648c18eebcb87f7bf">iParameterManager::ResolveParameter</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a> &amp;&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>param</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This is a convenience function to resolve a quest parameter during creation of rewards, triggers, and sequence operations. </p>
<p>This routine knows how to recognize parameter usage (starting with '$') and will in that case try to resolve the parameter by finding it in 'params'. Otherwise it will just return the unmodified string. This version doesn't support dynamic parameters. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>tools/<a class="el" href="parameters_8h_source.html">parameters.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
